#ifndef _MLista_h_	//Fichero MLista.h
#define _MLista_h_

#include "MErrores.h"
#include "MElemento.h"

using namespace std;
using namespace MErrores;
using namespace MElemento;


namespace MLista {

  struct TNodo
  {
     TElemento elem;
     TNodo *sig;
  };
  typedef TNodo *TLista;
  
  /* Devuelve cierto si la lista est vaca*/
  bool listaVacia(TLista l);

  /* Crea una lista vaca */
  void crearLista(TLista &l);  

  /* Destruye una lista previamente creada */
  void destruirLista(TLista &l);  
  
  /* Inserta en la lista un elemento ordenado por su nmero. 
     Si el elemento ya existe se produce un error. */
  void insertarLista(TLista &l, TElemento elem,TError &error); 
  
  /* Elimina de la lista un elemento dado su nmero. 
     Si el elemento no existe se produce un error.*/
  void eliminarLista(TLista &l, TNatural num, TError &error);

  /* Devuelve, si existe, un elemento dado su nmero. En caso de que no exista se producira un error. */
  void buscarLista(TLista l, TNatural num, TElemento &elem, TError &error);

  /* Imprime por pantalla la lista enlazada */        
  void escribirLista(TLista l); 
  
  /* Muestra por pantalla los smbolos de una lista de elementos ordenados por orden alfabtico.*/
  void ordenarLista (TLista &lista); 
  
  /* Dada una lista de elementos muestra por pantalla aquellos cuya masa atmica est entre min y max (ambos incluidos).*/
  void filtrarLista (TLista lista, double min, double max); 
  
  /* Vuelca al fichero con nombre nombre_fichero el contenido de una tabla.*/
  void escribirFicheroBIN (ofstream &fich, TLista lista, TError error); 

}
#endif

