#include "MTabla.h"

namespace MTabla {
          
   // FUNCIONES AUXILIARES
   
  void LeeStringBinario(ifstream &fich, string &s);
  void EscribeStringBinario(ofstream &fich, string s);
   
  void crearTabla(TTabla &tabla)
  {
       TNatural g;
       for (g=0;g<GRUPOS;g++)
       {
               crearLista(tabla[g]);
       }
  }

  
  void insertarElemento(TTabla &tabla, TElemento elem, TError &error)
  {
       TElemento temp;
       
       buscarElemento(tabla, elem.numero, temp, error);
       if (error==ErrorNoEncontrado)
       {
          insertarLista(tabla[elem.grupo-1], elem, error);
       }
       else 
       {
            error = ErrorElementoYaExiste;
       }
  } 
 
  void eliminarElemento(TTabla &tabla, TNatural num, TError &error)
  {
       string nombre;
       TElemento elem;
       
       buscarElemento(tabla, num, elem, error);
       if (error==NoError)
       {
          eliminarLista(tabla[elem.grupo-1],num,error);
       }
       
  }


  void buscarElemento(TTabla tabla, TNatural num, TElemento &elem, TError &error)
  {
       TNatural g;

       g=0;
       error = ErrorNoEncontrado;
       while ((g<GRUPOS)&& (error!=NoError))
       {
               buscarLista(tabla[g], num, elem, error);
               g++;
       }
   }
  

  void mostrarTabla (TTabla &tabla)
  {
       TNatural g;
       for (g=0;g<GRUPOS;g++)
       {
               escribirLista(tabla[g]);
       }
   } 
 
  
  void CargarTablaFichero(TTabla &tabla, string nomFich, TError &error)
  {
     ifstream fich;
     TElemento elem;
     
     fich.open(nomFich.c_str());
     if (fich.bad() || fich.fail())
     {
         error = ErrorFichero;
     }
     else
     {
        leerElementoFichero(fich, elem);  // Lectura Adelantada 
        while (!fich.eof())
         {
               insertarLista(tabla[elem.grupo-1],elem,error);
               leerElementoFichero(fich, elem);
         }                  
         fich.close();
     }
  }
  
 
  void destruirTabla(TTabla &tabla)
  {
       TNatural g;
       for (g=0;g<GRUPOS;g++)
       {
               destruirLista(tabla[g]);
       }
  }                      
 
  void ordenaGrupo (TTabla tabla, TNatural grupo)
  {
       ordenarLista(tabla[grupo-1]);
  }
  
  void filtrarTabla (TTabla tabla, double min, double max)
  {
       TNatural g;
       for (g=0;g<GRUPOS;g++)
       {
               filtrarLista(tabla[g],min,max);

       }
  }
  
  
  void cargarFicheroBIN (string nombre_fichero, TTabla &tabla, TError &error)
  {
     TElemento elem;
     ifstream in;
     
     in.open(nombre_fichero.c_str(),ios::binary);
     if (in.bad() || in.fail())
     {
         error = ErrorFichero;
     }
     else
     {
        leerElementoFicheroBIN(in, elem);  // Lectura Adelantada 
        while (!in.eof())
        {
               insertarLista(tabla[elem.grupo-1],elem,error);
               leerElementoFicheroBIN(in, elem); 
         }                  
        in.close();
     }
   }
  
  void salvarFicheroBIN (string nombre_fichero, TTabla tabla, TError &error)
  {
     TNatural g;
     ofstream out;
     
     out.open(nombre_fichero.c_str(),ios::binary);
     if (out.bad() || out.fail())
     {
         error = ErrorFichero;
     }
     else
     {
         error = NoError;
         for(g=0; g <GRUPOS; g++)
         {
             escribirFicheroBIN (out,tabla[g],error);
         }
         out.close();
     }
   }
   
  
}
