#ifndef _MTabla_h_	//fichero MTabla.h
#define _MTabla_h_

#include "MLista.h"

using namespace std;
using namespace MLista;

namespace MTabla {
  
  const unsigned int GRUPOS   = 18;

  typedef TLista TTabla[GRUPOS];
  
  /* Crea una tabla peridica vaca */
  void crearTabla(TTabla &tabla);

  /* Inserta un elemento en la posicin de la tabla dada por su grupo. 
     Si el elemento ya existe se produce un error.*/ 
  void insertarElemento(TTabla &tabla, TElemento elem, TError &error); 
 
  /* Elimina un elemento de la tabla dado su nmero. 
     Si el elemento no existe se produce un error. */
  void eliminarElemento(TTabla &tabla, TNatural num, TError &error);
  
  /* Devuelve, si existe, un elemento dado su nmero. 
     En caso de que no exista se producira un error. */  
  void buscarElemento(TTabla tabla, TNatural num, TElemento &elem, TError &error); 
  
  /* Muestra los elementos la tabla */
  void mostrarTabla (TTabla &tabla); 
  
  
  /* Inserta en una tabla los datos de los elementos guardados en un fichero 
     de texto con el formato especificado en el enunciado.*/
  void CargarTablaFichero(TTabla &tabla, string nomFich, TError &error);
  
   
  /* Elimina todos los elementos de la tabla. */
  void destruirTabla(TTabla &tabla);
  
  /* Muestra por pantalla los smbolos de los elementos de un grupo ordenados por orden alfabtico.*/
  void ordenaGrupo (TTabla tabla, TNatural grupo);
  
  /* Muestra por pantalla los elementos de la tabla cuya masa atmica est 
      entre min y max (ambos incluidos).*/
  void filtrarTabla (TTabla tabla, double min, double max);
  
  /* Lee el contenido del fichero binario con nombre nombre_fichero y lo almacena en una tabla.*/
  void cargarFicheroBIN (string nombre_fichero, TTabla &tabla, TError &error); 
  
  /* Vuelca al fichero con nombre nombre_fichero el contenido de una tabla.*/
  void salvarFicheroBIN (string nombre_fichero, TTabla tabla, TError &error);

}
 #endif
