/*----------------------------------------------------------------
|	Autor:                                                        |
|	Fecha:                            Versin: 1.0	              |
|-----------------------------------------------------------------|
|	Descripcin del Programa:                                     |
|  								                                  |
| ----------------------------------------------------------------*/

// Incluir E/S y Libreras Standard
#include <iostream>
#include <cstdlib>
#include "MTabla.h"
#include "MErrores.h"

using namespace std;
using namespace MTabla;
using namespace MErrores;

// Zona de Declaracin de Constantes
const char TAB   = '\t';

// Zona de Cabeceras de Procedimientos y Funciones
char menu();
bool ConfirmaSalida();


// Programa Principal
int main()
{
  // Zona de Declaracin de Variables del Programa principal
  bool salir;
  char op;
  TTabla tabla;
  TElemento elemento;
  TError error;
  string nombreFichero;
  TNatural grupo, num;
  double min, max;
  
  crearTabla(tabla);
  salir = false;  
  
  while(!salir)
  {
    op = menu();
    cout << endl;
    error = NoError;
    switch(op)
    {       
       case 'A': cout << "Nombre del fichero    : ";
                 getline(cin,nombreFichero,ENTER); 
                 CargarTablaFichero(tabla,  nombreFichero, error);
                 break;
       case 'B': mostrarTabla(tabla);
                 break;
       case 'C': cout << "No. del elemento      : ";
                 cin >> num;
                 cin.ignore();
                 buscarElemento(tabla, num, elemento, error);
                 if (error==NoError)
                 {
                    cout << endl;
                    cout << "Propiedades del elemento" << endl;
                    cout << "------------------------" << endl;
                    escribirElemento(elemento);
                    cout << endl;
                 }
                 break;
       case 'D': cout << "No. del elemento      : ";
                 cin >> num;
                 cin.ignore();
                 eliminarElemento(tabla, num, error);
                 break;
       case 'E': cout << "Grupo                 : ";
                 cin >> grupo;
                 cin.ignore();
                 ordenaGrupo(tabla, grupo);
                 break;
       case 'F': cout << "Masa mnima           : ";
                 cin >> min;
                 cout << "Masa mxima           : ";
                 cin >> max;
                 cin.ignore();
                 cout << endl;
                 filtrarTabla (tabla, min, max);
                 break;
       case 'G': cout << "Nombre del fichero    : ";
                 getline(cin,nombreFichero,ENTER); 
                 salvarFicheroBIN(nombreFichero,tabla, error);
                 break;
       case 'H': cout << "Nombre del fichero    : ";
                 getline(cin,nombreFichero,ENTER);
                 cargarFicheroBIN(nombreFichero,tabla,error);
                 break;
       case 'X': salir = ConfirmaSalida();
                 cout << endl << endl;
                 break;    
      }
      
    muestraError(error);
    system("Pause"); // Hacer una pausa
    system("cls");   // Borrar Pantalla
  }
  
  destruirTabla(tabla);
  return 0;	   // Valor de retorno al S.O.
}

// Implementacin de Procedimientos y Funciones
char menu()
{
  char op;
  cout << "Elaborado por: <Nombre> <Apellidos>" << TAB << "Curso 1A Sistemas" << endl;
  cout << "Fecha: 25/06/2009" << TAB << TAB << TAB << "Ordenador: <Ordenador>" << endl << endl;

  cout << "			MENU EXAMEN JUNIO 2009" << endl;
  cout << "			======================" << endl;
  
  cout << TAB << "   OPCIONES BASICAS" << endl;
  cout << TAB << "   ----------------" << endl;
  cout << TAB << "A. Leer elementos desde un fichero de texto e insertarlos en la tabla." << endl;
  cout << TAB << "B. Mostrar el contenido de la tabla." << endl;
  cout << TAB << "C. Buscar un elemento por su nmero atmico." << endl;
  cout << TAB << "D. Eliminar un elemento de la tabla dado su nmero." << endl << endl;
  
  cout << TAB << "   OPCIONES PARA ALUMNOS SIN NOTA DE CLASE" << endl;
  cout << TAB << "   ---------------------------------------" << endl;
  cout << TAB << "E. Ordenar los elementos de un grupo por sus smbolos." << endl << endl;
  
  cout << TAB << "   OPCIONES ADICIONALES" << endl;
  cout << TAB << "   --------------------" << endl;
  cout << TAB << "F. Filtrar la tabla." << endl;
  cout << TAB << "G. Salvar los datos de la tabla en un fichero binario." << endl;
  cout << TAB << "H. Cargar los datos de un fichero binario a una tabla." << endl << endl;

  cout << TAB << "X. Salir del Programa" << endl;

  cout << endl;
  cout << TAB << "Introduzca su opcion: " ;
  
  cin >> op;
  cin.ignore(); // Ignoro el ENTER
  op = toupper(op);
  
  while ( ((op<'A') || (op>'H')) && (op!='X') )
  {
    cout << "  Opcion Incorrecta ..." << endl;
    cout << endl;
    cout << "  Introduzca su opcion: " ;
    cin >> op;
    cin.ignore();
    op = toupper(op);  
  }  
  return op;
}

bool ConfirmaSalida()
{ 
  char car;

  cout << "?Esta seguro de salir (S/N)?";
  cin >> car;
  cin.ignore();
  car = toupper(car);
  
  return (car=='S');
}



